diff -Nru t1lib-grace/T1lib/t1lib/t1aaset.c t1lib-deb/T1lib/t1lib/t1aaset.c
--- t1lib-grace/T1lib/t1lib/t1aaset.c	2002-01-03 13:15:14.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1aaset.c	2007-12-23 07:49:42.000000000 -0800
@@ -2,11 +2,11 @@
   ----- File:        t1aaset.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
                      Subsampling based on code by Raph Levien (raph@acm.org)
-  ----- Date:        2001-04-01
+  ----- Date:        2007-12-21
   ----- Description: This file is part of the t1-library. It contains
                      functions for antialiased setting of characters
 		     and strings of characters.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001.
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2007.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -52,6 +52,7 @@
 #include "../type1/spaces.h"
 #include "../type1/util.h"
 #include "../type1/fontfcn.h"
+#include "../type1/paths.h"
 #include "../type1/regions.h"
 
 #include "t1types.h"
@@ -803,10 +804,10 @@
   if ((pFontBase->t1lib_flags & T1_AA_CACHING)) {
     if (transform==NULL){
       /* if size/aa is not existent we create it */
-      if ((font_ptr=QueryFontSize( FontID, size, T1aa_level))==NULL){
+      if ((font_ptr=T1int_QueryFontSize( FontID, size, T1aa_level))==NULL){
 	/* We create the required size struct and leave the rest
 	   for T1_SetChar() */
-	font_ptr=CreateNewFontSize( FontID, size, T1aa_level);
+	font_ptr=T1int_CreateNewFontSize( FontID, size, T1aa_level);
 	if (font_ptr==NULL){
 	  T1_errno=T1ERR_ALLOC_MEM;
 	  T1aa_level=savelevel;
@@ -962,11 +963,21 @@
   offset=0;
   target_ptr=aaglyph.bits;
   
-  /* We must check for n_vert==1 because the computation above is not
-     valid in this case */
-  if (n_vert==1)
-    v_start=v_start < v_end ? v_start : v_end;
+  /* We must check for n_vert==1 because then both v_start and v_end could / will
+     affect the same AA scan line. Because I'm forgetful, a reminder:
 
+          v_end |   000000000000000000000
+	        |   111111111111111111111  ^ 
+		Y   111111111111111111111  |
+                    000000000000000000000  | v_start
+
+     In order to count the v_end from bottom to top, we express it as (T1aa_level-v_end).
+     The number of rows to take into account is then v_start-(T1aa_level-v_end).
+  */
+  if (n_vert==1) {
+    v_start=v_start - (T1aa_level - v_end);
+  }
+  
   ptr = glyph->bits;
   for (i = 0; i < n_vert; i++) {
     if (i==0)
@@ -1184,10 +1195,12 @@
   offset=0;
   target_ptr=aastring_glyph.bits;
   
-  /* We must check for n_vert==1 because the computation above is not
-     valid in this case */
-  if (n_vert==1)
-    v_start=v_start < v_end ? v_start : v_end;
+  /* We must check for n_vert==1 because then both v_start and v_end could / will
+     affect the same AA scan line. 
+  */
+  if (n_vert==1) {
+    v_start=v_start - (T1aa_level - v_end);
+  }
   
   ptr = glyph->bits;
   for (i = 0; i < n_vert; i++) {
@@ -1219,6 +1232,220 @@
 
 
 
+/* T1_AASetRect(): Raster a rectangle, whose size is given in charspace units.
+   The resulting glyph does not cause any escapement. */
+GLYPH* T1_AASetRect( int FontID, float size,
+		     float width, float height, T1_TMATRIX *transform)
+{
+  GLYPH *glyph;   /* pointer to bitmap glyph */
+  static GLYPH aaglyph={NULL,{0,0,0,0,0,0},NULL,DEFAULTBPP};/* The anti-aliased glyph */
+  long asc, dsc, ht, wd;
+  long i;
+  long n_horz, n_horz_pad, n_vert, n_asc, n_dsc;
+  long v_start, v_end;
+  char *target_ptr;
+  long offset;
+  char *ptr;
+  int y;
+  long lsb, aalsb, aahstart;
+  int memsize;
+  LONG paddedW;
+  int savelevel;
+  
+
+  /* Reset character glyph, if necessary */
+  if (aaglyph.bits!=NULL){
+    free(aaglyph.bits);
+    aaglyph.bits=NULL;
+  }
+  aaglyph.metrics.leftSideBearing=0;
+  aaglyph.metrics.rightSideBearing=0;
+  aaglyph.metrics.advanceX=0;
+  aaglyph.metrics.advanceY=0;
+  aaglyph.metrics.ascent=0;
+  aaglyph.metrics.descent=0;
+  aaglyph.pFontCacheInfo=NULL;
+  aaglyph.bpp=T1aa_bpp;
+
+
+  /* Check for smart antialiasing */
+  savelevel=T1aa_level;
+  if (T1aa_SmartOn){
+    if (size>=T1aa_smartlimit2) {
+      T1aa_level=T1_AA_NONE;
+    }
+    else if (size>=T1aa_smartlimit1) {
+      T1aa_level=T1_AA_LOW;
+    }
+    else {
+      T1aa_level=T1_AA_HIGH;
+    }
+  }
+
+
+  /* First, call routine to rasterize character, all error checking is
+     done in this function: */ 
+  if ((glyph=T1_SetRect( FontID, T1aa_level*size, width, height, transform))==NULL){
+    /* restore level */
+    T1aa_level=savelevel;
+    return(NULL); /* An error occured */
+  }
+  
+  /* In case there are no black pixels, we simply set the dimensions and
+     then return */
+  if ( glyph->bits == NULL) {
+    aaglyph.bits=NULL;
+    aaglyph.metrics.leftSideBearing=0;
+    aaglyph.metrics.rightSideBearing=0;
+    aaglyph.metrics.advanceX=(int) floor(glyph->metrics.advanceX/(float)T1aa_level+0.5);
+    aaglyph.metrics.advanceY=(int) floor(glyph->metrics.advanceY/(float)T1aa_level+0.5);
+    aaglyph.metrics.ascent=0;
+    aaglyph.metrics.descent=0;
+    aaglyph.pFontCacheInfo=NULL;
+    /* restore level and return */
+    T1aa_level=savelevel;
+    return(&aaglyph);
+  }
+
+  /* Get dimensions of bitmap: */
+  asc=glyph->metrics.ascent;
+  dsc=glyph->metrics.descent;
+  lsb=glyph->metrics.leftSideBearing;
+  ht=asc-dsc;
+  wd=glyph->metrics.rightSideBearing-lsb;
+  
+  if (T1aa_level==T1_AA_NONE){
+    /* we only convert bitmap to bytemap */
+    aaglyph=*glyph;
+    aaglyph.bpp=T1aa_bpp;
+    /* Compute scanline length and such */
+    n_horz_pad=PAD( wd*T1aa_bpp, pFontBase->bitmap_pad )>>3;
+    /* Allocate memory for glyph */
+    memsize = n_horz_pad*ht*8;
+    /*    aaglyph.bits = (char *)malloc(memsize*sizeof( char)); */
+    aaglyph.bits = (char *)malloc(memsize*sizeof( char));
+    if (aaglyph.bits == NULL) {
+      T1_errno=T1ERR_ALLOC_MEM;
+      /* restore level */
+      T1aa_level=savelevel;
+      return(NULL);
+    }
+    paddedW=PAD(wd,pFontBase->bitmap_pad)>>3;
+    ptr=glyph->bits;
+    target_ptr=aaglyph.bits;
+    for (i = 0; i < ht; i++) {
+      T1_DoLine ( wd, paddedW, ptr, target_ptr );
+      ptr += paddedW;
+      target_ptr += n_horz_pad;
+    }
+    /* restore level */
+    T1aa_level=savelevel;
+    return(&aaglyph);
+  }
+  
+
+  /* Set some looping parameters for subsampling */
+  if (lsb<0){
+    aalsb=lsb/T1aa_level-1;
+    aahstart=T1aa_level+(lsb%T1aa_level);
+  }
+  else{
+    aalsb=lsb/T1aa_level;
+    aahstart=lsb%T1aa_level;
+  }
+  
+  /* The horizontal number of steps: */
+  n_horz=(wd+aahstart+T1aa_level-1)/T1aa_level;
+  /* And the padded value */
+  n_horz_pad=PAD( n_horz*T1aa_bpp, pFontBase->bitmap_pad )>>3;
+
+  /* vertical number of steps: */
+  if (asc % T1aa_level){ /* not aligned */
+    if ( asc > 0){
+      n_asc=asc/T1aa_level+1;
+      v_start=asc % T1aa_level;
+    }
+    else{
+      n_asc=asc/T1aa_level;
+      v_start=T1aa_level + (asc % T1aa_level); 
+    }
+  }
+  else{
+    n_asc=asc/T1aa_level;
+    v_start=T1aa_level;
+  }
+  if (dsc % T1aa_level){ /* not aligned */
+    if ( dsc < 0){
+      n_dsc=dsc/T1aa_level-1;
+      v_end=-(dsc % T1aa_level);
+    }
+    else{
+      n_dsc=dsc/T1aa_level;
+      v_end=T1aa_level - (dsc % T1aa_level);
+    }
+  }
+  else{
+    n_dsc=dsc/T1aa_level;
+    v_end=T1aa_level;
+  }
+  /* the total number of lines: */
+  n_vert=n_asc-n_dsc;
+  
+  /* Allocate memory for glyph */
+  memsize = n_horz_pad*n_vert;
+
+  /* Note: we allocate 12 bytes more than necessary */
+  aaglyph.bits = (char *)malloc(memsize*sizeof( char) +12);
+  if (aaglyph.bits == NULL) {
+    T1_errno=T1ERR_ALLOC_MEM;
+    /* restore level */
+    T1aa_level=savelevel;
+    return(NULL);
+  }
+  
+
+  paddedW=PAD(wd,pFontBase->bitmap_pad)/8;
+  offset=0;
+  target_ptr=aaglyph.bits;
+  
+  /* We must check for n_vert==1 because then both v_start and v_end could / will
+     affect the same AA scan line. 
+  */
+  if (n_vert==1) {
+    v_start=v_start - (T1aa_level - v_end);
+  }
+
+  ptr = glyph->bits;
+  for (i = 0; i < n_vert; i++) {
+    if (i==0)
+      y=v_start;
+    else if (i==n_vert-1)
+      y=v_end;
+    else
+      y=T1aa_level;
+    T1_AADoLine ( T1aa_level, wd, y, paddedW, ptr, target_ptr, aahstart );
+    ptr += y * paddedW;
+    target_ptr += n_horz_pad;
+  }
+  
+  /* .. and set them in aaglyph */
+  aaglyph.metrics.leftSideBearing=aalsb;
+  aaglyph.metrics.rightSideBearing=aalsb + n_horz;
+  aaglyph.metrics.advanceX=(int) floor(glyph->metrics.advanceX/(float)T1aa_level+0.5);
+  aaglyph.metrics.advanceY=(int) floor(glyph->metrics.advanceY/(float)T1aa_level+0.5);
+  aaglyph.metrics.ascent=n_asc;
+  aaglyph.metrics.descent=n_dsc;
+  aaglyph.pFontCacheInfo=NULL;
+
+  /* restore level */
+  T1aa_level=savelevel;
+
+  return(&aaglyph);
+
+}
+
+
+
 /* T1_AASetGrayValues(): Sets the byte values that are put into the
    pixel position for the respective entries:
    Returns 0 if successfull.
@@ -1230,7 +1457,7 @@
 		       unsigned long black)
 {
   
-  if (CheckForInit()){
+  if (T1_CheckForInit()){
     T1_errno=T1ERR_OP_NOT_PERMITTED;
     return(-1);
   }
@@ -1259,7 +1486,7 @@
 {
   int i;
   
-  if (CheckForInit()){
+  if (T1_CheckForInit()){
     T1_errno=T1ERR_OP_NOT_PERMITTED;
     return(-1);
   }
@@ -1288,7 +1515,7 @@
 int T1_AANSetGrayValues( unsigned long bg, unsigned long fg)
 {
   
-  if (CheckForInit()){
+  if (T1_CheckForInit()){
     T1_errno=T1ERR_OP_NOT_PERMITTED;
     return(-1);
   }
@@ -1313,7 +1540,7 @@
 {
   int i;
   
-  if (CheckForInit()) {
+  if (T1_CheckForInit()) {
     T1_errno=T1ERR_OP_NOT_PERMITTED;
     return(-1);
   }
@@ -1332,14 +1559,14 @@
 
 
 
-/* Get the current setting of graylevels for 2x antialiasing. The 17
+/* Get the current setting of graylevels for 4x antialiasing. The 17
    values are stored at address pgrayvals in order from background to
    foreground */
 int T1_AAHGetGrayValues( long *pgrayvals) 
 {
   int i;
 
-  if (CheckForInit()) {
+  if (T1_CheckForInit()) {
     T1_errno=T1ERR_OP_NOT_PERMITTED;
     return(-1);
   }
@@ -1350,20 +1577,20 @@
   }
 
   for ( i=0; i<17; i++) { /* bg (i=0)  to fg (i=16) */
-    pgrayvals[i]=gv[i];
+    pgrayvals[i]=gv_h[i];
   }
   return( 0);
 }
 
 
 
-/* Get the current setting of graylevels for 2x antialiasing. The 2
+/* Get the current setting of graylevels for no antialiasing. The 2
    values are stored at address pgrayvals in order from background to
    foreground */
 int T1_AANGetGrayValues( long *pgrayvals) 
 {
 
-  if (CheckForInit()) {
+  if (T1_CheckForInit()) {
     T1_errno=T1ERR_OP_NOT_PERMITTED;
     return(-1);
   }
@@ -1372,8 +1599,8 @@
     T1_errno=T1ERR_INVALID_PARAMETER;
     return(-1);
   }
-  pgrayvals[0]=gv[0]; /* background */
-  pgrayvals[1]=gv[1]; /* foreground */
+  pgrayvals[0]=gv_n[0]; /* background */
+  pgrayvals[1]=gv_n[1]; /* foreground */
   return( 0);
 }
 
@@ -1385,7 +1612,7 @@
 int  T1_AASetBitsPerPixel( int bpp)
 {
   
-  if (CheckForInit()){
+  if (T1_CheckForInit()){
     T1_errno=T1ERR_OP_NOT_PERMITTED;
     return(-1);
   }
@@ -1425,7 +1652,7 @@
 int T1_AASetLevel( int level)
 {
   
-   if (CheckForInit()){
+   if (T1_CheckForInit()){
      T1_errno=T1ERR_OP_NOT_PERMITTED;
      return(-1);
    }
@@ -1606,10 +1833,12 @@
   offset=0;
   target_ptr=aaglyph.bits;
   
-  /* We must check for n_vert==1 because the computation above is not
-     valid in this case */
-  if (n_vert==1)
-    v_start=v_start < v_end ? v_start : v_end;
+  /* We must check for n_vert==1 because then both v_start and v_end could / will
+     affect the same AA scan line.
+  */
+  if (n_vert==1) {
+    v_start=v_start - (T1aa_level - v_end);
+  }
 
   ptr = glyph->bits;
   for (i = 0; i < n_vert; i++) {
diff -Nru t1lib-grace/T1lib/t1lib/t1aaset.h t1lib-deb/T1lib/t1lib/t1aaset.h
--- t1lib-grace/T1lib/t1lib/t1aaset.h	2002-01-03 13:15:14.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1aaset.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1aaset.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-04-01
+  ----- Date:        2003-01-02
   ----- Description: This file is part of the t1-library. It contains
                      definitions and declarations for t1set.c.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2003. 
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -32,6 +32,9 @@
 GLYPH *T1_AASetString( int FontID, char *string, int len,
 		       long spaceoff, int modflag,
 		       float size, T1_TMATRIX *transform);
+GLYPH* T1_AASetRect( int FontID, float size,
+		     float width, float height,
+		     T1_TMATRIX *transform);
 int T1_AASetGrayValues( unsigned long white,
 			unsigned long gray75,
 			unsigned long gray50,
@@ -57,6 +60,9 @@
 extern GLYPH *T1_AASetString( int FontID, char *string, int len,
 			      long spaceoff, int modflag,
 			      float size, T1_TMATRIX *transform);
+extern GLYPH* T1_AASetRect( int FontID, float size,
+			  float width, float height,
+			  T1_TMATRIX *transform);
 extern int T1_AASetGrayValues( unsigned long white,
 			       unsigned long gray75,
 			       unsigned long gray50,
diff -Nru t1lib-grace/T1lib/t1lib/t1afmtool.c t1lib-deb/T1lib/t1lib/t1afmtool.c
--- t1lib-grace/T1lib/t1lib/t1afmtool.c	2002-07-29 13:37:48.000000000 -0700
+++ t1lib-deb/T1lib/t1lib/t1afmtool.c	2007-12-23 07:49:42.000000000 -0800
@@ -1,11 +1,11 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1afmtool.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-04-01
+  ----- Date:        2007-12-23
   ----- Description: This file is part of the t1-library. It contains
                      functions for generating a fallback set of afm data
 		     from type 1 font files.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001.
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2007.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -52,6 +52,7 @@
 #include "../type1/spaces.h"
 #include "../type1/util.h"
 #include "../type1/fontfcn.h"
+#include "../type1/paths.h"
 #include "../type1/regions.h"
 #include "../type1/blues.h"
 
@@ -89,6 +90,13 @@
   char **charnames;
   int nochars=0;
   FontInfo *pAFMData;
+
+  /* When generaing fallback info, we accumulate a font bounding box that
+     could be useful when the font's definition is missing or trivial. */
+  int acc_llx=0;
+  int acc_lly=0;
+  int acc_urx=0;
+  int acc_ury=0;
   
   
   /* We return to this if something goes wrong deep in the rasterizer */
@@ -103,7 +111,7 @@
   
 
   /* Check whether font is loaded: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     sprintf( err_warn_msg_buf,
 	     "Can't generate AFM Info from Font %d (invalid ID)\n", FontID);
     T1_PrintLog( "T1_GenerateAFMFallbackInfo()", err_warn_msg_buf,
@@ -236,6 +244,21 @@
 	pAFMData->cmi[i].charBBox.ury =0;
       }
       pAFMData->cmi[i].ligs=NULL;
+
+      /* Accumulate bounding box of font */
+      if ( pAFMData->cmi[i].charBBox.llx < acc_llx ) {
+	acc_llx=pAFMData->cmi[i].charBBox.llx;
+      }
+      if ( pAFMData->cmi[i].charBBox.lly < acc_lly ) {
+	acc_lly=pAFMData->cmi[i].charBBox.lly;
+      }
+      if ( pAFMData->cmi[i].charBBox.urx > acc_urx ) {
+	acc_urx=pAFMData->cmi[i].charBBox.urx;
+      }
+      if ( pAFMData->cmi[i].charBBox.ury > acc_ury ) {
+	acc_ury=pAFMData->cmi[i].charBBox.ury;
+      }
+      
       /* We are done with area, so get rid of it. Solves the REALLY
 	 HUGE memory leak */
       KillRegion (area);
@@ -246,6 +269,24 @@
 	   nochars, FontID);
   T1_PrintLog( "T1_GenerateAFMFallbackInfo()", err_warn_msg_buf,
 	       T1LOG_STATISTIC);
+
+  /* Check whether the bounding box we computed could be better than that
+     specified in the font file itself. Id so, we overwrite it. */
+  if ( pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[0].data.integer == 0   &&
+       pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[1].data.integer == 0   &&
+       pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[2].data.integer == 0   &&
+       pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[3].data.integer == 0 ) {
+    pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[0].data.integer = acc_llx;  
+    pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[1].data.integer = acc_lly;  
+    pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[2].data.integer = acc_urx;  
+    pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[3].data.integer = acc_ury;
+    
+    sprintf( err_warn_msg_buf,
+	     "Substituted accumulated FontBBox [%d,%d,%d,%d] for trivial FontBBox of font %d!",
+	     acc_llx, acc_lly, acc_urx, acc_ury, FontID);
+    T1_PrintLog( "T1_GenerateAFMFallbackInfo()", err_warn_msg_buf,
+		 T1LOG_WARNING);
+  }
   
   /* make sure to free S */
   if (S) {
@@ -281,7 +322,7 @@
   
 
   /* Check for valid font */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     sprintf( err_warn_msg_buf,
 	     "Warning: Invalid FontID, font %d not loaded!",
 	     FontID);
